# VisualStudioProject

API Documentation: | `VisualStudioProject`

Note: This class is incubating and may change in a future version of Gradle.

A visual studio project, created from one or more `NativeBinary` instances.

The content and location of the generate project file can be modified by the supplied methods:

    apply plugin: "visual-studio"
    model {
        visualStudio {
            projects.all {
                projectFile.location = "vs/${name}.vcxproj"
                projectFile.withXml {
                    asNode().appendNode('PropertyGroup', [Label: 'Custom'])
                            .appendNode('ProjectDetails', "Project is named ${project.name}")
                }
            }
        }
    }

### Properties

Property | Description
`buildDependencies` | Returns a dependency which contains the tasks which build this artifact. All `Buildable` implementations must ensure that the returned dependency object is live, so that it tracks changes to the dependencies of this buildable.
`buildTask` | Incubating The 'lifecycle' task associated with the construction of this element.
`filtersFile` | Incubating Configuration for the generated filters file.
`projectFile` | Incubating Configuration for the generated project file.

### Methods

Method | Description
`builtBy(tasks)` | Incubating Adds a task that is required for the construction of this element. A task added this way is then added as a dependency of the associated lifecycle task.

### Script blocks

No script blocks

### Property details

#### `TaskDependency` `buildDependencies` (read-only)

Returns a dependency which contains the tasks which build this artifact. All `Buildable` implementations must ensure that the returned dependency object is live, so that it tracks changes to the dependencies of this buildable.

#### `Task` `buildTask`

Note: This property is incubating and may change in a future version of Gradle.

The 'lifecycle' task associated with the construction of this element.

#### `XmlConfigFile` `filtersFile` (read-only)

Note: This property is incubating and may change in a future version of Gradle.

Configuration for the generated filters file.

#### `XmlConfigFile` `projectFile` (read-only)

Note: This property is incubating and may change in a future version of Gradle.

Configuration for the generated project file.

### Method details

#### `void` `builtBy`(``Object`...` tasks)

Note: This method is incubating and may change in a future version of Gradle.

Adds a task that is required for the construction of this element. A task added this way is then added as a dependency of the associated lifecycle task.